clear all
close all
clc

format long eng

a = 65532; % koeficient nasobenia
b = 65536; % koeficient delenia


coeff_dn = a/b % koeficient v desatinnej podobe
normal_dn = 1.0/ (-coeff_dn + 1.0) % truncation

to = 3*48000; %dlzka simulacie      


%*********************************
% pociatocne podmienky
 out1(to) = 0;
 sig = 970;
 w5 = 4000;
 acc = 0;
 
 s2 = 970/4000
 b2 = 1
 a2 = 0
 % *********************************
 % priprava vektrov na ulozenie hodnot
 float_num = zeros(1,to);
 real_num = zeros(1,to);
 
 % *****************************
 
 for t = 1:to
    
    % simulacia s float point
     b2 = s2/normal_dn + b2 * coeff_dn;
float_num(t) = b2*4000;
     
  % simulacia ako to prebieha v DSPic
  
     % vynulovanie hornych 16b z 32b 
     bh = fix(acc/2^16);
     bl = acc - bh*2^16;
     
     
     acc = bl + sig*4; % do akumulatoru vedla 16b zbytku
                       % sa prida aj truncated hodnota signalu
                        
     acc = acc + w5 * 65532; % vynasoby sa hodnota predosla s 65532 a prida sa k acc
     w5 = fix(acc / 65536);% do wk sa ulozi hodnota vydelena 65535 // akoby sa vynasobilo 0.999938964843750
     
 % ulozenie hodnoty na vykreslenie    
 real_num(t) = w5;    

 end
 
% vykreslenie vysledkov 
figure('Position',[70 120 570 430])
plot(float_num,'r')
hold on
plot(real_num)
grid on
 
% vykreslenie chyby
figure('Position',[60 110 560 420])
plot(real_num - float_num)
grid on

% *********************************************************************************
% ukazka co by sa stalo kebyze sa neulozi zvysok po deleni
% (lsb 16b z ACCx)



% pociatocne podmienky stejne ako v predoslom pripade
 out1(to) = 0;
 sig = 970;
 w5 = 4000;
 acc = 0;

 real_num_bez = zeros(1,to);

 for t = 1:to
         
     
     acc =  sig*4; % do akumulatoru vedla 16b zbytku
                       % sa prida aj truncated hodnota signalu
                        
     acc = acc + w5 * 65532; % vynasoby sa hodnota predosla s 65532 a prida sa k acc
     w5 = fix(acc / 65536);% do wk sa ulozi hodnota vydelena 65535 // akoby sa vynasobilo 0.999938964843750
     
 % ulozenie hodnoty na vykreslenie    
 real_num_bez(t) = w5;    

 end

figure(figure('Position',[50 100 550 410]))
% vykreslenie vysledkov 
plot(float_num,'g')
hold on
plot(real_num_bez,'r')
grid on
 



%**************************************************************************
% pociatocne podmienky
 out1(to) = 0;
 sig = 970;
 w5 = 4000;
 acc = 0;
 
 real_num_8 = zeros(1,to);
 
 % *****************************
 
 for t = 1:to
    
     
  % simulacia ako to prebieha v DSPic
  
     % vynulovanie hornych 16b z 32b 
     bh = fix(acc/2^13);
     bl = acc - bh*2^13;
     
     
     acc = bl + sig*4/4; % do akumulatoru vedla 16b zbytku
                       % sa prida aj truncated hodnota signalu
                        
     acc = acc + w5 * 8191; % vynasoby sa hodnota predosla s 65532 a prida sa k acc
     w5 = fix(acc / 8192);% do wk sa ulozi hodnota vydelena 65535 // akoby sa vynasobilo 0.999938964843750
     
 % ulozenie hodnoty na vykreslenie    
 real_num_8(t) = w5;    

 end
 
% vykreslenie vysledkov 
figure('Position',[40 90 540 400])
plot(float_num,'r')
hold on
plot(real_num_8)
grid on
 
% vykreslenie chyby
figure('Position',[30 80 530 390])
plot(real_num_8 - float_num)

grid on
 