clear all
close all
clc


sig = [4000.* ones(1,4000) 970.* ones(1,25000)   470+800*(1+sin(0:0.00009:7))  5350.* ones(1,4000) 1220.* ones(1,9200)];

plot(sig)



out = zeros(1,length(sig));

coeff_up = 0.00001;
normal_up = 1/ (-coeff_up +1);

coeff_dn = 65532/65536
normal_dn = 1/ (-coeff_dn +1)



buff = sig(1)*normal_dn;
for i = 1:length(sig)

    
    if sig(i)*normal_dn > buff
        buff =  sig(i)*normal_dn;
        out(i) = buff/normal_dn;
    else
        buff = (buff*coeff_dn + sig(i));
        out(i) = buff/normal_dn ;
    end
    
end

hold on
plot(out,'r')

grid on